rawset(_G, "CV_PTJE", {}) -- for console vars

COM_AddCommand("makepizza", function(player, arg)
	if gametype ~= GT_PIZZATIMEJISK then
		CONS_Printf(player, "Command must be ran in the Pizza Time Jisk Edition mode.")
		return
	end
	if tonumber(arg) == nil then
		CONS_Printf(player, "arg1 must be a number.")
		return
	end
	if not arg then
		CONS_Printf(player, "makepizza <playernum>")
		return
	end
	
	if players[tonumber(arg)] then
		local targetplayer = players[tonumber(arg)]
		if targetplayer and targetplayer.valid and not targetplayer.pizzaface then
			targetplayer.pizzaface = true
			chatprint("\x85*"..targetplayer.name.." has become a pizza!")
			PTJE_add_announcement(5*TICRATE,"\x85*"..targetplayer.name.." has become a pizza!")
		end
	else
		CONS_Printf(player, "Player does not exist")
	end
end,1)

COM_AddCommand("doannouncement", function(player, text)
	if gametype ~= GT_PIZZATIMEJISK then
		CONS_Printf(player, "Command must be ran in the Pizza Time Jisk Edition mode.")
		return
	end
	if text == nil then
		CONS_Printf(player, "arg1 must be valid.")
		return
	end
	
	
	
	jisk_addannouncement(3*TICRATE,"\x82\*"..text)
end,1)

CV_PTJE.forcelap = CV_RegisterVar({
	name = "jisk_forcelap",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.maxlaps = CV_RegisterVar({
	name = "jisk_maxlaps",
	defaultvalue = "16",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.maxlaps_perplayer = CV_RegisterVar({
	name = "jisk_maxlaps_perplayer",
	defaultvalue = "5",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.lappingtype = CV_RegisterVar({
	name = "jisk_lappingtype",
	defaultvalue = "2",
	flags = CV_NETVAR,
	PossibleValue = {shared = 1, perplayer = 2}, 
})

CV_PTJE.pizzatimestun = CV_RegisterVar({
	name = "jisk_pizzatimestun",
	defaultvalue = "10",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.fakelapstun = CV_RegisterVar({
	name = "jisk_fakelapstun",
	defaultvalue = "3",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.tpinv = CV_RegisterVar({
	name = "jisk_tpinv",
	defaultvalue = "3", -- IN SECONDS
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.dynamiclaps = CV_RegisterVar({
	name = "jisk_dynamiclaps",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.showdeaths = CV_RegisterVar({
	name = "jisk_showdeaths",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.pizzalaugh = CV_RegisterVar({ -- Whenever the pizzaface laugh plays when pizzatime starts.
	name = "jisk_pizzalaugh",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.homework = CV_RegisterVar({
	name = "jisk_homework",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.collisionsystem = CV_RegisterVar({
	name = "jisk_collisionsystem",
	defaultvalue = "1",
	flags = CV_NETVAR,
	PossibleValue = {line = 1},  -- , locationcheck = 2
})

CV_PTJE.timelimit = CV_RegisterVar({
	name = "jisk_timelimit",
	defaultvalue = "4", -- in minutes
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.pizzachoosetype = CV_RegisterVar({
	name = "jisk_pizzachoosetype",
	defaultvalue = "2",
	flags = CV_NETVAR,
	PossibleValue = {firsttrigger = 1, random = 2}, 
})

CV_PTJE.playerschoosing = CV_RegisterVar({
	name = "jisk_playerschoosing",
	defaultvalue = "1", -- in minutes
	flags = CV_NETVAR,
	PossibleValue = CV_Natural, 
})

CV_PTJE.pizzatpcooldown = CV_RegisterVar({
	name = "jisk_pizzatpcooldown",
	defaultvalue = "5",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.pizzatpstuntime = CV_RegisterVar({
	name = "jisk_pizzatpstuntime",
	defaultvalue = "2",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
})

CV_PTJE.nomusic = CV_RegisterVar({
	name = "jisk_nomusic",
	defaultvalue = "off",
	PossibleValue = CV_OnOff, 
})

CV_PTJE.scoreonkill = CV_RegisterVar({
	name = "jisk_scoreonkill",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})

CV_PTJE.screams = CV_RegisterVar({
	name = "jisk_screams",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})


CV_PTJE.pizzamask = CV_RegisterVar({
	name = "jisk_pizzamask",
	defaultvalue = "on",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
})
