freeslot("sfx_pizzah", "sfx_pepdi1","sfx_pepdi2","sfx_pepdi3","sfx_pepdi4","sfx_pepdi5", "sfx_pepdi6","sfx_lap2")

customhud.SetupFont("PTFNT", -1, 4);

rawset(_G, "FUNC_PTJE", {}) -- functions


G_AddGametype({
    name = "Pizza Time Jisk Edition",
    identifier = "PIZZATIMEJISK",
    typeoflevel = TOL_RACE,
    rules = GTR_FRIENDLY|GTR_SPAWNENEMIES|GTR_TIMELIMIT,
    intermissiontype = int_match,
    headercolor = 35,
    description = "Run away from pizzaface, in style!"
})



rawset(_G, "PTJE", { -- variables
	spawn_location = 
	{x = 0, y = 0, z = 0, angle = 0}, -- where the sign is at the start of the map
	
	end_location = 
	{x = 0, y = 0, z = 0, angle = 0}, -- where the sign originally was in the map placement
	
	pizzatime = false,
	dynamic_maxlaps = 0,
	laps = 0,
	quitting = false,
	pizzatime_tics = 0,
	
	timeleft = 0,
	
	timeover = false,
	
	endsector = nil,
	
	hudstuff = {
		anim = 0,
		anim_active = false,
		
		rev = false,
		wait_tics = 0,
		
		stop = false,
	},
	
	maxrankpoints = 0,
})

addHook("NetVars", function(net)
	local sync_list = {
		"spawn_location",
		"end_location",
		"pizzatime",
		"dynamic_maxlaps",
		"laps",
		"quitting",
		"pizzatime_tics",
		"timeleft",
		"timeover",
		"endsector",
		
		"hudstuff",
		
		"maxrankpoints",
	}
	
	for i,v in ipairs(sync_list) do
		PTJE[v] = net($)
	end
end)


local function ResetPlayerVars(player)	
	player.pizzaface = false
	player.pizzamask = nil
	player.stuntime = 0
	player.spectator = false
	player.lapsdid = 0
	player.laptime = 0
	player["PT@hudstuff"] = PTJE.hudstuff
end

PTJE.spawn_location_atdefault = (
PTJE.spawn_location.x == 0 and 
PTJE.spawn_location.y == 0 and 
PTJE.spawn_location.z == 0 and 
PTJE.spawn_location.angle == 0
) -- returns true if at the defaults

PTJE.end_location_atdefault = (
PTJE.end_location.x == 0 and 
PTJE.end_location.y == 0 and 
PTJE.end_location.z == 0 and 
PTJE.end_location.angle == 0
) -- returns true if at the defaults



rawset(_G, "JISK_COUNT", do
	local playerCount = 0
	local exitingCount = 0
	local pizzaCount = 0
	for player in players.iterate
		if player.valid
			if player.pizzaface then
				pizzaCount = $+1
			end
			if player.exiting or player.spectator or player.pizzaface or (player.playerstate == PST_DEAD and PTJE.pizzatime)
				exitingCount = $+1
			end
		end
		playerCount = $+1
	end
	return exitingCount,playerCount, pizzaCount
end)




--heres where the values reset when maps load
local function InitMap()
	PTJE.pizzatime = false -- doesn't matter what gamemode it is, just make it false all the time.
    PTJE.spawn_location = {x = 0, y = 0, z = 0}
    PTJE.endsector = nil
	PTJE.laps = 0
	PTJE.quitting = false
	PTJE.dynamic_maxlaps = 0
	PTJE.pizzatime_tics = 0 
	PTJE.timeleft = 0
	PTJE.timeover = false
end

local function InitMap2()
    if gametype ~= GT_PIZZATIMEJISK then return end
    for map in mapthings.iterate do
        if map.type == 1 then
            PTJE.spawn_location.x = map.x
            PTJE.spawn_location.y = map.y
            PTJE.spawn_location.z = map.z
            PTJE.spawn_location.angle = map.angle
        end
		
        if map.type == 501 then
            PTJE.end_location.x = map.x
            PTJE.end_location.y = map.y
            PTJE.end_location.z = map.z
            PTJE.end_location.angle = map.angle
        end
    end
	-- dont use the playercount function since it will iterate through all players twice
	-- so make a non functioned playercount
	local playercount = 0
	for player in players.iterate() do
	
		playercount = $ + 1	
		-- INCREMENT OVER --
		ResetPlayerVars(player)	
	end
	PTJE.dynamic_maxlaps = playercount*2
	
	PTJE.maxrankpoints = PTJE.GetRingCount()*1500
	
end



-- doesnt actually trigger or increment lap, just tps you
PTJE.LapTP = function(player, invincibility)
	if not player and not player.mo and not player.mo.valid then return end -- safety
	player.exiting = 0
	P_SetOrigin(player.mo, PTJE.end_location.x*FRACUNIT,PTJE.end_location.y*FRACUNIT, PTJE.end_location.z*FRACUNIT)
	player.mo.angle = PTJE.end_location.angle - ANGLE_90
	
	if invincibility then
		player.powers[pw_invulnerability] = CV_PTJE.tpinv.value*TICRATE -- converts to seconds
	end
end
--does the parameters shit for you.


PTJE.StartNewLap = function(mobj)
	local player = mobj.player
	
	if not player.pizzaface then
		PTJE.LapTP(player, true)
		
		PTJE.laps = $ + 1
		

		S_StartSound(nil, sfx_lap2, player)
		
		
		player.laptime = 0
		
		
		

		
		-- Elfilin support
		
		if player.elfilin and player.mo.elfilin_portal then
			player.mo.elfilin_portal.fuse = 1
		end
	

		
	else -- FAKE LAP -- 
		mobj.player.stuntime = TICRATE*CV_PTJE.fakelapstun.value
		P_SetOrigin(mobj, PTJE.end_location.x*FRACUNIT,PTJE.end_location.y*FRACUNIT, PTJE.end_location.z*FRACUNIT)
		mobj.angle = PTJE.end_location.angle - ANGLE_90
	end
	
end 


PTJE.PizzaTimeTrigger = function(mobj)
	if not (PTJE.pizzatime and PTJE.spawn_location_atdefault) then
		PTJE.pizzatime = true
		
		local thesign = P_SpawnMobj(0,0,0, MT_SIGN)
		P_SetOrigin(thesign, PTJE.spawn_location.x*FRACUNIT, PTJE.spawn_location.y*FRACUNIT, PTJE.spawn_location.z*FRACUNIT)
		thesign.angle = PTJE.spawn_location.angle
		
		if thesign.subsector then
			PTJE.endsector = thesign.subsector.sector
		end
		
		PTJE.timeleft = CV_PTJE.timelimit.value*TICRATE*60
		PTJE.laps = 1
		
		--hit the player that touched the location with these variables
		local _, playerCount = JISK_COUNT()
		if playerCount > 1 then
			if CV_PTJE.pizzachoosetype.value == 1 then
				mobj.player.pizzaface = true
				mobj.player.stuntime = TICRATE*CV_PTJE.pizzatimestun.value
				chatprint("\x85*"..mobj.player.name.." has become a pizza!") 
			elseif CV_PTJE.pizzachoosetype.value == 2 then
				local active_playernums = {}
				local playerschoosing = CV_PTJE.playerschoosing.value
				
				if playerCount < playerschoosing then
					playerschoosing = 1
				end
				if playerschoosing then
					-- store every playernum
					for player in players.iterate() do
						table.insert(active_playernums, #player)
						
					end
					-- loop for every pizza needed
					for i=1,playerschoosing do
						local chosen_playernum = P_RandomRange(1,#active_playernums) -- random entry in table
						local chosen_player = active_playernums[chosen_playernum] -- get the chosen value in table
						players[chosen_player].pizzaface = true
						players[chosen_player].stuntime = TICRATE*CV_PTJE.pizzatimestun.value
						chatprint("\x85*"..players[chosen_player].name.." has become a pizza!") 
						table.remove(active_playernums, chosen_playernum) -- so we dont repeat the pizza given
					end
				end
			end
		end
		for player in players.iterate() do
			local pmo = player.mo
			player.lapsdid = 1
			P_SetOrigin(pmo, PTJE.end_location.x*FRACUNIT,PTJE.end_location.y*FRACUNIT, PTJE.end_location.z*FRACUNIT)
			pmo.angle = PTJE.end_location.angle - ANGLE_90
			if not player.pizzaface then
				player.powers[pw_invulnerability] = CV_PTJE.tpinv.value*TICRATE
			end
		end     
	end
end

PTJE.GetRingCount = function()
	local count = 0
	for mobj in mobjs.iterate() do
		if mobj.type == MT_RING then
			count = $ + 1
		end
	end
	
	return count
end



addHook("MapChange", InitMap)
addHook("MapLoad", InitMap)
addHook("MapLoad", InitMap2)