freeslot("MT_PIZZAMASK", "S_PIZZAFACE", "SPR_PZAT")

mobjinfo[MT_PIZZAMASK] = {
	doomednum = -1,
	spawnstate = S_PIZZAFACE,
	spawnhealth = 1000,
	deathstate = S_NULL,
	radius = 16*FU,
	height = 48*FU,
	flags = MF_NOCLIP|MF_NOGRAVITY
}


states[S_PIZZAFACE] = {
    sprite = SPR_PZAT,
    frame = FF_ANIMATE|A,
    tics = -1,
    var1 = 15,
    var2 = 2,
    nextstate = SPR_PZAT
}

--Pizza Face Thinker
addHook("PlayerThink", function(player)
	player.stuntime = $ or 0 
	if gametype ~= GT_PIZZATIMEJISK then return end
	if player.realmo and player.realmo.valid and player.pizzaface and leveltime then
		if player.redgreen == nil then
			player.redgreen = $ or false
		end
		player.pizzacharge = $ or 0
		player.pizzachargecooldown = $ or 0
		
		
		P_SetScale(player.realmo, 2*FU)
		
		player.spectator = false -- dont give up! dont spectate as pizzaface! (theres another check when spawning so idk 
		
		if player.stuntime then -- player freeze decrement (mainly for pizza faces)
			player.stuntime = $ - 1
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.pflags = $|PF_FULLSTASIS
			if not player.stuntime and CV_PTJE.pizzalaugh.value and not player.pizzachargecooldown then -- once it hits zero, LAUGH AHHHHAHHAAHAHAHHAHAH
				S_StartSound(player.mo, sfx_pizzah)
			end
		end
		
		player.redgreen = not player.redgreen
		

		if (not player.pizzamask or not player.pizzamask.valid) and CV_PTJE.pizzamask.value then
			player.pizzamask = P_SpawnMobj(player.realmo.x,player.realmo.y,player.realmo.z,MT_PIZZAMASK)
			player.pizzamask.targetplayer = player --dream reference
			player.pizzamask.scale = FU/2
		end
		
		if player.pizzamask then
			player.realmo.flags2 = $|MF2_DONTDRAW -- invisible so that the pizza mask can draw over.
		else
			player.mo.color = SKINCOLOR_ORANGE
			player.mo.colorized = true
		end
		
		
		
		if (leveltime % 3) and player.pizzamask and player.pizzamask.valid then

			if player.redgreen then
				local ghost = P_SpawnGhostMobj(player.pizzamask)
				ghost.fuse = 3
				ghost.colorized = true
				ghost.color = SKINCOLOR_RED
				ghost.frame = $|FF_TRANS10
			else
				local ghost = P_SpawnGhostMobj(player.pizzamask)
				ghost.fuse = 3
				ghost.colorized = true
				ghost.color = SKINCOLOR_GREEN
				ghost.frame = $|FF_TRANS10
			end
		end
		if player.exiting or PTJE.quitting then
			player.pizzacharge = 0
		end
		if not player.exiting and (player.cmd.buttons & BT_ATTACK) 
		and not PTJE.quitting and not player.stuntime and not player.pizzachargecooldown then -- basically check if you're active in general
			if player.pizzacharge < TICRATE then
				player.pizzacharge = $ + 1
			else
				local peppinos = {} -- temp list of chosen players, or "peppinos" in this case.

				-- we will have "peppino" as the alias because conflicts
				for peppino in players.iterate() do
					if not peppino.pizzaface and (peppino.mo and peppino.mo.valid) and 
					not peppino.spectator and not peppino.exiting and (peppino.playerstate == PST_LIVE)
					and not peppino.quittime then 
						table.insert(peppinos, #peppino)
					end
				end
				local chosen_peppinonum = P_RandomRange(1,#peppinos) -- random entry in table
				local chosen_peppino = peppinos[chosen_peppinonum] -- get the chosen value in table
				if peppinos ~= {} then
					player.pizzacharge = 0
					player.pizzachargecooldown = CV_PTJE.pizzatpcooldown.value*TICRATE
					player.stuntime = CV_PTJE.pizzatpstuntime.value*TICRATE
				
					P_SetOrigin(player.mo, players[chosen_peppino].mo.x,players[chosen_peppino].mo.y,players[chosen_peppino].mo.z)
					S_StartSound(player.mo, sfx_pizzah)
				end

			end
		elseif player.pizzacharge > 0 then
			player.pizzacharge = $ - 1
		end
		
		if player.pizzachargecooldown then
			player.pizzachargecooldown = $ - 1
		end
		--print(player.pizzacharge)
		/*
		if not p.mo.colorized or p.mo.color != SKINCOLOR_ORANGE
			p.mo.color = SKINCOLOR_ORANGE
			p.mo.colorized = true		
		end
		*/
	end
end)

-- Pizza Mask Thinker
addHook("MobjThinker", function(mobj)
	if gametype ~= GT_PIZZATIMEJISK then return end
	if mobj.targetplayer and mobj.targetplayer.valid and mobj.targetplayer.mo and mobj.targetplayer.mo.valid then
		local targetplayer = mobj.targetplayer
		P_MoveOrigin(mobj, targetplayer.mo.x, targetplayer.mo.y, targetplayer.mo.z)
	end
end, MT_PIZZAMASK)

--THE BADNIKS ARENT PIZZAHEAD'S ENEMY
addHook("ShouldDamage", function(target, inflictor)
	if target.valid and target.player and target.player.pizzaface then 
	--and inflictor and inflictor.valid and (inflictor.flags & MF_ENEMY)  
	--this code is gone because we want pizzaface to not die
		return false
	end
end)
 -- taken from the original since barely anything needs to be changed
addHook("MobjCollide", function(mo1, mo2)
	if not PTJE.pizzatime then return end
	if not (mo1.player and mo1.valid and mo1.player.valid) then return end
	if not (mo2.player and mo2.valid and mo2.player.valid) or (mo2.player and not mo2.player.pizzaface) then return end -- only continue if mo2 is pizzaface
	if mo2.player.stuntime then return end
	if mo1.player.exiting then return end
	if mo1.player.powers[pw_invulnerability] then return end
	if mo1.player.powers[pw_flashing] then return end
	if mo1.player.pizzaface then return end -- lets not tag our buddies!!
	if not L_ZCollide(mo1,mo2) then return end
	
	P_KillMobj(mo1,mo2)
end, MT_PLAYER)


